#include "channel_node.h"

#include "mixer.h"
#include "mixer_track.h"

null_channel_node* null_channel_node::instance;

mixer_channel_node::mixer_channel_node(channel_interface* in_owner, mixer_track* in_track, uint32_t in_node_index): channel_node(
        in_owner, channel_node_type::mixer), track_(in_track), node_index_(0) {
    const auto& headers = in_track->buffer.get_headers_vector();

    channel_headers_.push_back(headers[in_node_index * 2]);
    channel_headers_.push_back(headers[in_node_index * 2 + 1]);
}

const std::vector<sample_t*>& null_channel_node::get_channel_headers() {
    return g_mixer.zero_track->buffer.get_headers_vector();
}
