#include <iostream>
#include <thread>
#if PLATFORM_WINDOWS
#include <windows.h>
#include <processthreadsapi.h>
#elif PLATFORM_LINUX
#include <pthread.h>
#elif PLATFORM_MACOS
#include <pthread.h>
#endif

void set_thread_name(const char* name) {
#if PLATFORM_WINDOWS
    SetThreadDescription(GetCurrentThread(), std::wstring(name, name + strlen(name)).c_str());
#elif PLATFORM_LINUX
    pthread_setname_np(pthread_self(), name);
#elif PLATFORM_MACOS
    pthread_setname_np(name);
#endif
}
