#pragma once

#include <queue>

#include "mempool.h"
#include "thread_message.h"

class CORE_API thread_message_hub {
public:
    template<typename T, typename ...Args>
    void push_message(Args&&... args) {
        T* message = mem_pool_.alloc<T>(std::forward<Args>(args)...);
        push_message(message);
    }
    template<typename T>
    void push_message() {
        T* message = mem_pool_.alloc<T>();
        push_message(message);
    }
    void push_message(thread_message* message) {
        messages_.push(message);
    }
    void push_message(const std::function<void()>& func) {
        lamba_thread_message* message = mem_pool_.alloc<lamba_thread_message>(func);
        push_message(message);
    }
    void process_messages();
private:
    std::queue<thread_message*> messages_;
    mempool mem_pool_ = mempool(1024000);
};
